commit 63758bead0337b5225016711bf9d540cf7cc80b1
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Wed Jun 30 17:00:58 2021

    libstdc++: Improve Doxygen documentation groups [PR 101258]
    
    This defines some new Doxygen groups for C++17 variable templates and
    for the contents of <experimental/type_traits>. By documenting the group
    as a whole and adding each template to a group we don't need to document
    them individually.
    
    Also mark more internals with "@cond undocumented" so that Doxygen
    ignores them by default. Also make Doxygen process <experimental/simd>.
    
    For some reason, many of the class templates in <type_traits> do not
    appear in the "Metaprogramming" group. For example, add_cv,
    remove_extent, and all the is_xxx_constructible and is_xxx_assignable
    traits. For some reason, Doxygen doesn't include them in the group,
    despite doing it correctly for other traits in the same header.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/101258
            * doc/doxygen/user.cfg.in (INPUT): Add <experimental/simd>.
            (COLS_IN_ALPHA_INDEX): Remove obsolete tag.
            (PREDEFINED): Add/fix some more macros that need to be expanded.
            * include/bits/random.h: Stop Doxygen from documenting internal
            implementation details.
            * include/bits/random.tcc: Likewise.
            * include/bits/this_thread_sleep.h: Fix @file name.
            * include/experimental/bits/simd.h: Add to Doxygen group. Do not
            document internal implementation details.
            * include/experimental/bits/simd_detail.h: Do not document
            internal implementation details.
            * include/experimental/simd: Define Doxygen groups.
            * include/experimental/type_traits: Improve documentation for
            the header file. Define groups. Use @since commands.
            * include/std/scoped_allocator (scoped_allocator_adaptor): Move
            declaration before undocumented region.
            * include/std/type_traits (true_type, false_type): Use using
            declaration instead of typedef.
            (is_invocable_v, is_nothrow_invocable_v, is_invocable_r_v)
            (is_nothrow_invocable_r_v): Move definitions next to other C++17
            variable templates.
            Do not document internal implementation details. Move misplaced
            group-end command. Define group for variable templates.
            * include/std/variant: Do not document internal implementation
            details.
            * testsuite/26_numerics/random/pr60037-neg.cc: Adjust dg-error
            line number.
    
    (cherry picked from commit 6963c3b9ed1308bf5d2d8877956e56fec92853a7)

diff --git a/libstdc++-v3/doc/doxygen/user.cfg.in b/libstdc++-v3/doc/doxygen/user.cfg.in
index 4be2e19ce50..2c7df479a25 100644
--- a/libstdc++-v3/doc/doxygen/user.cfg.in
+++ b/libstdc++-v3/doc/doxygen/user.cfg.in
@@ -1013,6 +1013,7 @@ INPUT                  = @srcdir@/doc/doxygen/doxygroups.cc \
                          include/experimental/ratio \
                          include/experimental/regex \
                          include/experimental/set \
+                         include/experimental/simd \
                          include/experimental/string \
                          include/experimental/string_view \
                          include/experimental/system_error \
@@ -1334,13 +1335,6 @@ CLANG_DATABASE_PATH    =
 
 ALPHABETICAL_INDEX     = YES
 
-# The COLS_IN_ALPHA_INDEX tag can be used to specify the number of columns in
-# which the alphabetical index list will be split.
-# Minimum value: 1, maximum value: 20, default value: 5.
-# This tag requires that the tag ALPHABETICAL_INDEX is set to YES.
-
-COLS_IN_ALPHA_INDEX    = 2
-
 # In case all classes in a project start with a common prefix, all classes will
 # be put under the same header in the alphabetical index. The IGNORE_PREFIX tag
 # can be used to specify a prefix (or a list of prefixes) that should be ignored
@@ -2415,7 +2409,8 @@ PREDEFINED             = __cplusplus=201703L \
                          "_GLIBCXX_END_NAMESPACE_CXX11= " \
                          "_GLIBCXX_END_NAMESPACE_LDBL= " \
                          "_GLIBCXX_TEMPLATE_ARGS=...  " \
-                         _GLIBCXX_DEPRECATED \
+                         "_GLIBCXX_DEPRECATED= " \
+                         "_GLIBCXX_DEPRECATED_SUGGEST(E)= " \
                          _GLIBCXX_CONSTEXPR=constexpr \
                          _GLIBCXX_USE_CONSTEXPR=constexpr \
                          "_GLIBCXX_THROW(E)= " \
@@ -2430,6 +2425,7 @@ PREDEFINED             = __cplusplus=201703L \
                          _GLIBCXX_USE_NANOSLEEP \
                          __cpp_exceptions \
                          __cpp_rtti \
+                         __cpp_inline_variables \
                          ATOMIC_INT_LOCK_FREE=2 \
                          PB_DS_DATA_TRUE_INDICATOR \
                          PB_DS_STATIC_ASSERT=// \
@@ -2440,11 +2436,16 @@ PREDEFINED             = __cplusplus=201703L \
                          __glibcxx_class_requires2=// \
                          __glibcxx_class_requires3=// \
                          __glibcxx_class_requires4=// \
-                         "__attribute__(X)=" \
+                         "__attribute__(X)= " \
                          _GLIBCXX14_CONSTEXPR=constexpr \
                          _GLIBCXX17_CONSTEXPR=constexpr \
                          _GLIBCXX20_CONSTEXPR=constexpr \
-                         _GLIBCXX17_DEPRECATED= \
+                         "_GLIBCXX11_DEPRECATED= " \
+                         "_GLIBCXX11_DEPRECATED_SUGGEST(E)= " \
+                         "_GLIBCXX17_DEPRECATED= " \
+                         "_GLIBCXX17_DEPRECATED_SUGGEST(E)= " \
+                         "_GLIBCXX20_DEPRECATED(E)= " \
+                         "_GLIBCXX20_DEPRECATED(E)= " \
                          _GLIBCXX17_INLINE=inline
 
 # If the MACRO_EXPANSION and EXPAND_ONLY_PREDEF tags are set to YES then this
diff --git a/libstdc++-v3/include/bits/random.h b/libstdc++-v3/include/bits/random.h
index 1b9cc5f16a9..941fa9858c2 100644
--- a/libstdc++-v3/include/bits/random.h
+++ b/libstdc++-v3/include/bits/random.h
@@ -60,9 +60,8 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
     _RealType
     generate_canonical(_UniformRandomNumberGenerator& __g);
 
-  /*
-   * Implementation-space details.
-   */
+  /// @cond undocumented
+  // Implementation-space details.
   namespace __detail
   {
     template<typename _UIntType, size_t __w,
@@ -212,6 +211,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       >;
 
   } // namespace __detail
+  /// @endcond
 
   /**
    * @addtogroup random_generators Random Number Generators
diff --git a/libstdc++-v3/include/bits/random.tcc b/libstdc++-v3/include/bits/random.tcc
index 1357e181874..4c00b119549 100644
--- a/libstdc++-v3/include/bits/random.tcc
+++ b/libstdc++-v3/include/bits/random.tcc
@@ -36,9 +36,8 @@ namespace std _GLIBCXX_VISIBILITY(default)
 {
 _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
-  /*
-   * (Further) implementation-space details.
-   */
+  /// @cond undocumented
+  // (Further) implementation-space details.
   namespace __detail
   {
     // General case for x = (ax + c) mod m -- use Schrage's algorithm
@@ -90,6 +89,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       }
 
   } // namespace __detail
+  /// @endcond
 
   template<typename _UIntType, _UIntType __a, _UIntType __c, _UIntType __m>
     constexpr _UIntType
diff --git a/libstdc++-v3/include/bits/this_thread_sleep.h b/libstdc++-v3/include/bits/this_thread_sleep.h
index a87da388ec5..bdcd0cdeb77 100644
--- a/libstdc++-v3/include/bits/this_thread_sleep.h
+++ b/libstdc++-v3/include/bits/this_thread_sleep.h
@@ -22,7 +22,7 @@
 // see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 // <http://www.gnu.org/licenses/>.
 
-/** @file bits/std_thread_sleep.h
+/** @file bits/this_thread_sleep.h
  *  This is an internal header file, included by other library headers.
  *  Do not attempt to use it directly. @headername{thread}
  */
diff --git a/libstdc++-v3/include/experimental/bits/simd.h b/libstdc++-v3/include/experimental/bits/simd.h
index 59ddf3cc958..421c923e7b0 100644
--- a/libstdc++-v3/include/experimental/bits/simd.h
+++ b/libstdc++-v3/include/experimental/bits/simd.h
@@ -45,6 +45,9 @@
 #include <arm_neon.h>
 #endif
 
+/** @ingroup ts_simd
+ * @{
+ */
 /* There are several closely related types, with the following naming
  * convention:
  * _Tp: vectorizable (arithmetic) type (or any type)
@@ -3976,6 +3979,7 @@ template <typename _Tp, typename _Abi, size_t _Np>
 
 // }}}
 
+/// @cond undocumented
 // _SmartReference {{{
 template <typename _Up, typename _Accessor = _Up,
 	  typename _ValueType = typename _Up::value_type>
@@ -4257,6 +4261,7 @@ template <typename _Tp, size_t _Np, typename>
   struct __deduce_impl : public __deduce_fixed_size_fallback<_Tp, _Np> {};
 
 //}}}1
+/// @endcond
 
 // simd_mask {{{
 template <typename _Tp, typename _Abi>
@@ -4604,6 +4609,7 @@ template <typename _Tp, typename _Abi>
 
 // }}}
 
+/// @cond undocumented
 // __data(simd_mask) {{{
 template <typename _Tp, typename _Ap>
   _GLIBCXX_SIMD_INTRINSIC constexpr const auto&
@@ -4616,6 +4622,7 @@ template <typename _Tp, typename _Ap>
   { return __x._M_data; }
 
 // }}}
+/// @endcond
 
 // simd_mask reductions [simd_mask.reductions] {{{
 template <typename _Tp, typename _Abi>
@@ -4758,6 +4765,7 @@ find_last_set(_ExactBool)
 
 // }}}
 
+/// @cond undocumented
 // _SimdIntOperators{{{1
 template <typename _V, typename _Impl, bool>
   class _SimdIntOperators {};
@@ -4878,6 +4886,7 @@ template <typename _V, typename _Impl>
   };
 
 //}}}1
+/// @endcond
 
 // simd {{{
 template <typename _Tp, typename _Abi>
@@ -5153,6 +5162,7 @@ template <typename _Tp, typename _Abi>
   };
 
 // }}}
+/// @cond undocumented
 // __data {{{
 template <typename _Tp, typename _Ap>
   _GLIBCXX_SIMD_INTRINSIC constexpr const auto&
@@ -5190,7 +5200,9 @@ template <typename _Tp, typename _Ap>
 	    _Ap::_SimdImpl::_S_bit_and(__data(__a), __data(__b))};
   }
 } // namespace __float_bitwise_operators }}}
+/// @endcond
 
+/// @}
 _GLIBCXX_SIMD_END_NAMESPACE
 
 #endif // __cplusplus >= 201703L
diff --git a/libstdc++-v3/include/experimental/bits/simd_detail.h b/libstdc++-v3/include/experimental/bits/simd_detail.h
index 1e75812d098..ecd059610cd 100644
--- a/libstdc++-v3/include/experimental/bits/simd_detail.h
+++ b/libstdc++-v3/include/experimental/bits/simd_detail.h
@@ -30,6 +30,7 @@
 #include <cstddef>
 #include <cstdint>
 
+/// @cond undocumented
 
 #define _GLIBCXX_SIMD_BEGIN_NAMESPACE                                          \
   namespace std _GLIBCXX_VISIBILITY(default)                                   \
@@ -300,6 +301,8 @@
 #define _GLIBCXX_SIMD_FIX_P2TS_ISSUE66 1
 // }}}
 
+/// @endcond
+
 #endif // __cplusplus >= 201703L
 #endif // _GLIBCXX_EXPERIMENTAL_SIMD_DETAIL_H_
 
diff --git a/libstdc++-v3/include/experimental/simd b/libstdc++-v3/include/experimental/simd
index beccbc14fa5..6f867a9d52d 100644
--- a/libstdc++-v3/include/experimental/simd
+++ b/libstdc++-v3/include/experimental/simd
@@ -35,6 +35,23 @@
 
 #if __cplusplus >= 201703L
 
+/** @defgroup par-ts Parallelism TS
+ *  @ingroup experimental
+ *
+ * Components defined by the _C++ Extensions for Parallelism_
+ * Technical Specification.
+ *
+ * - ISO/IEC TS 19570:2015 C++ Extensions for Parallelism
+ * - ISO/IEC TS 19570:2018 C++ Extensions for Parallelism, Version 2
+ */
+
+/** @defgroup ts_simd Data parallel extensions
+ *  @ingroup par-ts
+ *
+ *  Data-parallel types library.
+ *  @since C++17
+ */
+/// @ingroup ts_simd
 #define __cpp_lib_experimental_parallel_simd 201803
 
 #pragma GCC diagnostic push
diff --git a/libstdc++-v3/include/experimental/type_traits b/libstdc++-v3/include/experimental/type_traits
index 39ada113463..b90641905ce 100644
--- a/libstdc++-v3/include/experimental/type_traits
+++ b/libstdc++-v3/include/experimental/type_traits
@@ -24,7 +24,14 @@
 
 /** @file experimental/type_traits
  *  This is a TS C++ Library header.
+ *
+ *  This header defines variable templates for the C++14 type traits.
+ *
+ *  Equivalent variable templates are defined in namespace `std` since C++17.
+ *  @see variable_templates
+ *
  *  @ingroup libfund-ts
+ *  @since C++14
  */
 
 //
@@ -49,6 +56,14 @@ namespace experimental
 {
 inline namespace fundamentals_v1
 {
+/** @defgroup lfts_variable_templates Variable template for type traits
+ * @ingroup libfund-ts
+ * @since Library Fundamentals TS v1. C++14.
+ * @see variable_templates
+ */
+/** @ingroup lfts_variable_templates
+ * @{
+ */
 #define __cpp_lib_experimental_type_trait_variable_templates 201402
 
 // See C++14 20.10.4.1, primary type categories
@@ -213,7 +228,7 @@ template <typename _Base, typename _Derived>
   constexpr bool is_base_of_v = is_base_of<_Base, _Derived>::value;
 template <typename _From, typename _To>
   constexpr bool is_convertible_v = is_convertible<_From, _To>::value;
-
+/// @}
 
   // 3.3.2, Other type transformations
   // invocation_type (still unimplemented)
@@ -224,14 +239,24 @@ template <typename _From, typename _To>
 
 inline namespace fundamentals_v2
 {
+/**
+ * @defgroup lfts_detect Detection idiom
+ * @ingroup libfund-ts
+ * @since Library Fundamentals TS v2. C++14.
+ */
+/** @ingroup lfts_detect
+ * @{
+ */
 #define __cpp_lib_experimental_detect 201505
 
 // [meta.detect]
 
+/// A metafunction that always yields void, used for detecting valid types.
 template<typename...> using void_t = void;
 
 #pragma GCC diagnostic push
 #pragma GCC diagnostic ignored "-Wctor-dtor-privacy"
+/// @internal
 struct __nonesuchbase {};
 struct nonesuch : private __nonesuchbase
 {
@@ -272,7 +297,16 @@ template<typename _To, template<typename...> class _Op, typename... _Args>
 template<typename _To, template<typename...> class _Op, typename... _Args>
   constexpr bool is_detected_convertible_v
     = is_detected_convertible<_To, _Op, _Args...>::value;
+/// @}
 
+/**
+ * @defgroup lfts_logical Logical operator traits
+ * @ingroup libfund-ts
+ * @since Library Fundamentals TS v2. C++14.
+ */
+/** @ingroup lfts_logical
+ * @{
+ */
 #define __cpp_lib_experimental_logical_traits 201511
 
 template<typename... _Bn>
@@ -301,6 +335,7 @@ template<typename... _Bn>
 template<typename _Pp>
   constexpr bool negation_v
     = negation<_Pp>::value;
+/// @}
 } // namespace fundamentals_v2
 } // namespace experimental
 
diff --git a/libstdc++-v3/include/std/scoped_allocator b/libstdc++-v3/include/std/scoped_allocator
index 2d2bd72c4a6..34a9c800f45 100644
--- a/libstdc++-v3/include/std/scoped_allocator
+++ b/libstdc++-v3/include/std/scoped_allocator
@@ -53,6 +53,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
    * @{
    */
 
+  template<typename _OuterAlloc, typename... _InnerAllocs>
+    class scoped_allocator_adaptor;
+
   /// @cond undocumented
 
   template<typename _Alloc>
@@ -81,15 +84,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       { return __base::_S_outermost(__a.outer_allocator()); }
     };
 
-  /// Implementation of the OUTERMOST pseudofunction
+  // Implementation of the OUTERMOST pseudofunction
   template<typename _Alloc>
     inline typename __outermost_type<_Alloc>::type&
     __outermost(_Alloc& __a)
     { return __outermost_type<_Alloc>::_S_outermost(__a); }
 
-  template<typename _OuterAlloc, typename... _InnerAllocs>
-    class scoped_allocator_adaptor;
-
   template<typename...>
     struct __inner_type_impl;
 
